unit ICSubs;

interface

	uses
{$ifc undefined THINK_Pascal}
		Types, 
{$endc}
		ICTypes;

	function ICMapErr (icerr: ICError): OSErr;
	function ICGetPrefStr (inst: ICInstance; key: Str255; var attr: ICAttr; var str: Str255): ICError;
	function ICSetPrefStr (inst: ICInstance; key: Str255; attr: ICAttr; str: Str255): ICError;

implementation

	uses
{$ifc undefined THINK_Pascal}
		Memory, Resources, QuickDraw, AppleTalk, Aliases, Files,
{$endc}
		ICKeys, ICAPI;

	function ICMapErr (icerr: ICError): OSErr;
	begin
		if (icerr < -32768) or (icerr > 32767) then begin
			icerr := icInternalErr;
		end; (* if *)
		ICMapErr := icerr;
	end; (* ICMapErr *)

{$PUSH}
{$R-}
	function ICGetPrefStr (inst: ICInstance; key: Str255; var attr: ICAttr; var str: Str255): ICError;
		var
			err: ICError;
			size: longint;
	begin
		size := 256;
		err := ICGetPref(inst, key, attr, @str, size);
		if err <> noErr then begin
			str := '';
		end; (* if *)
		ICGetPrefStr := err;
	end; (* ICGetPrefStr *)

	function ICSetPrefStr (inst: ICInstance; key: Str255; attr: ICAttr; str: Str255): ICError;
	begin
		ICSetPrefStr := ICSetPref(inst, key, attr, @str, length(str) + 1);
	end; (* ICSetPrefStr *)
{$POP}

end. (* ICSubs *)